diff --git a/gdb/amd64-linux-nat.c b/gdb/amd64-linux-nat.c
index 844343c..2aabf37 100644
--- a/gdb/amd64-linux-nat.c
+++ b/gdb/amd64-linux-nat.c
@@ -1283,42 +1283,28 @@ x86_linux_read_btrace (struct target_ops *self,
   return linux_read_btrace (data, btinfo, type);
 }
 
-/* Provide a prototype to silence -Wmissing-prototypes.  */
-void _initialize_amd64_linux_nat (void);
+/* Create an x86 GNU/Linux target.  */
 
-void
-_initialize_amd64_linux_nat (void)
+static struct target_ops *
+x86_linux_create_target (void)
 {
-  struct target_ops *t;
-
-  amd64_native_gregset32_reg_offset = amd64_linux_gregset32_reg_offset;
-  amd64_native_gregset32_num_regs = I386_LINUX_NUM_REGS;
-  amd64_native_gregset64_reg_offset = amd64_linux_gregset_reg_offset;
-  amd64_native_gregset64_num_regs = AMD64_LINUX_NUM_REGS;
-
-  gdb_assert (ARRAY_SIZE (amd64_linux_gregset32_reg_offset)
-	      == amd64_native_gregset32_num_regs);
-
   /* Fill in the generic GNU/Linux methods.  */
-  t = linux_target ();
+  struct target_ops *t = linux_target ();
 
+  /* Initialize the debug register function vectors.  */
   i386_use_watchpoints (t);
-
   i386_dr_low.set_control = x86_linux_dr_set_control;
   i386_dr_low.set_addr = x86_linux_dr_set_addr;
   i386_dr_low.get_addr = x86_linux_dr_get_addr;
   i386_dr_low.get_status = x86_linux_dr_get_status;
   i386_dr_low.get_control = x86_linux_dr_get_control;
-  i386_set_debug_register_length (8);
+  i386_set_debug_register_length (sizeof (void *));
 
   /* Override the GNU/Linux inferior startup hook.  */
   super_post_startup_inferior = t->to_post_startup_inferior;
   t->to_post_startup_inferior = x86_linux_child_post_startup_inferior;
 
-  /* Add our register access methods.  */
-  t->to_fetch_registers = amd64_linux_fetch_inferior_registers;
-  t->to_store_registers = amd64_linux_store_inferior_registers;
-
+  /* Add the description reader.  */
   t->to_read_description = x86_linux_read_description;
 
   /* Add btrace methods.  */
@@ -1328,11 +1314,47 @@ _initialize_amd64_linux_nat (void)
   t->to_teardown_btrace = x86_linux_teardown_btrace;
   t->to_read_btrace = x86_linux_read_btrace;
 
-  /* Register the target.  */
+  return t;
+}
+
+/* Register an x86 GNU/Linux target.  */
+
+static void
+x86_linux_register_target (struct target_ops *t)
+{
   linux_nat_add_target (t);
   linux_nat_set_new_thread (t, x86_linux_new_thread);
   linux_nat_set_new_fork (t, x86_linux_new_fork);
   linux_nat_set_forget_process (t, i386_forget_process);
-  linux_nat_set_siginfo_fixup (t, amd64_linux_siginfo_fixup);
   linux_nat_set_prepare_to_resume (t, x86_linux_prepare_to_resume);
 }
+
+/* Provide a prototype to silence -Wmissing-prototypes.  */
+void _initialize_amd64_linux_nat (void);
+
+void
+_initialize_amd64_linux_nat (void)
+{
+  struct target_ops *t;
+
+  amd64_native_gregset32_reg_offset = amd64_linux_gregset32_reg_offset;
+  amd64_native_gregset32_num_regs = I386_LINUX_NUM_REGS;
+  amd64_native_gregset64_reg_offset = amd64_linux_gregset_reg_offset;
+  amd64_native_gregset64_num_regs = AMD64_LINUX_NUM_REGS;
+
+  gdb_assert (ARRAY_SIZE (amd64_linux_gregset32_reg_offset)
+	      == amd64_native_gregset32_num_regs);
+
+  /* Create a generic x86 GNU/Linux target.  */
+  t = x86_linux_create_target ();
+
+  /* Add our register access methods.  */
+  t->to_fetch_registers = amd64_linux_fetch_inferior_registers;
+  t->to_store_registers = amd64_linux_store_inferior_registers;
+
+  /* Register the target.  */
+  x86_linux_register_target (t);
+
+  /* Add our siginfo layout converter.  */
+  linux_nat_set_siginfo_fixup (t, amd64_linux_siginfo_fixup);
+}
diff --git a/gdb/i386-linux-nat.c b/gdb/i386-linux-nat.c
index 9794a09..e4ae160 100644
--- a/gdb/i386-linux-nat.c
+++ b/gdb/i386-linux-nat.c
@@ -1231,37 +1231,28 @@ x86_linux_read_btrace (struct target_ops *self,
   return linux_read_btrace (data, btinfo, type);
 }
 
-/* -Wmissing-prototypes */
-extern initialize_file_ftype _initialize_i386_linux_nat;
+/* Create an x86 GNU/Linux target.  */
 
-void
-_initialize_i386_linux_nat (void)
+static struct target_ops *
+x86_linux_create_target (void)
 {
-  struct target_ops *t;
-
   /* Fill in the generic GNU/Linux methods.  */
-  t = linux_target ();
+  struct target_ops *t = linux_target ();
 
+  /* Initialize the debug register function vectors.  */
   i386_use_watchpoints (t);
-
   i386_dr_low.set_control = x86_linux_dr_set_control;
   i386_dr_low.set_addr = x86_linux_dr_set_addr;
   i386_dr_low.get_addr = x86_linux_dr_get_addr;
   i386_dr_low.get_status = x86_linux_dr_get_status;
   i386_dr_low.get_control = x86_linux_dr_get_control;
-  i386_set_debug_register_length (4);
-
-  /* Override the default ptrace resume method.  */
-  t->to_resume = i386_linux_resume;
+  i386_set_debug_register_length (sizeof (void *));
 
   /* Override the GNU/Linux inferior startup hook.  */
   super_post_startup_inferior = t->to_post_startup_inferior;
   t->to_post_startup_inferior = x86_linux_child_post_startup_inferior;
 
-  /* Add our register access methods.  */
-  t->to_fetch_registers = i386_linux_fetch_inferior_registers;
-  t->to_store_registers = i386_linux_store_inferior_registers;
-
+  /* Add the description reader.  */
   t->to_read_description = x86_linux_read_description;
 
   /* Add btrace methods.  */
@@ -1271,10 +1262,37 @@ _initialize_i386_linux_nat (void)
   t->to_teardown_btrace = x86_linux_teardown_btrace;
   t->to_read_btrace = x86_linux_read_btrace;
 
-  /* Register the target.  */
+  return t;
+}
+
+/* Register an x86 GNU/Linux target.  */
+
+static void
+x86_linux_register_target (struct target_ops *t)
+{
   linux_nat_add_target (t);
   linux_nat_set_new_thread (t, x86_linux_new_thread);
   linux_nat_set_new_fork (t, x86_linux_new_fork);
   linux_nat_set_forget_process (t, i386_forget_process);
   linux_nat_set_prepare_to_resume (t, x86_linux_prepare_to_resume);
 }
+
+/* -Wmissing-prototypes */
+extern initialize_file_ftype _initialize_i386_linux_nat;
+
+void
+_initialize_i386_linux_nat (void)
+{
+  /* Create a generic x86 GNU/Linux target.  */
+  struct target_ops *t = x86_linux_create_target ();
+
+  /* Override the default ptrace resume method.  */
+  t->to_resume = i386_linux_resume;
+
+  /* Add our register access methods.  */
+  t->to_fetch_registers = i386_linux_fetch_inferior_registers;
+  t->to_store_registers = i386_linux_store_inferior_registers;
+
+  /* Register the target.  */
+  x86_linux_register_target (t);
+}